#ifndef MQTT_CONTROL_H
#define MQTT_CONTROL_H

#include <PubSubClient.h>
#include <ESP8266WiFi.h>
#include "Izm_config.h" // Подключаем объявления переменных

// Внешние переменные
extern float Temp[9];
extern float pressure[4];
extern uint8_t ntcEn[9];
extern float Alc_T;
extern int8_t spk_on;
extern float T_target;
extern String savedSSID;
extern String savedPass;
extern bool hotspotMode;
extern String mqtt_server;
extern uint mqtt_port;
extern String mqtt_user;
extern String mqtt_password;
extern String mqtt_topic_temp;
extern String mqtt_topic_press;
extern String mqtt_topic_alc;
extern String mqtt_topic_status;
//------------------------------------------Значения для датчиков давления-------------------------------------------------
 extern int8_t Pressure_enable[4];  
 extern float pressure[4], temperature[4], B25, B25t; 
 extern float dPress_1, KTemp_1, BaseTemp_1, dPt_1, ADSt1, ADSt, PressureBaseADS, PressureQ, KTemp_2, BaseTemp, dPress_2, dPt_2, BaseTemp_2, U33, Uref, R10, R62;
 extern float HX710B_Mult, KTemp_3, BaseTemp_3, dPress_3, Pressure3Temp, dPt_3;
 extern uint8_t N_dPressureAlc;  
 extern float k_Alc_T, k_Alc, Alc, Alc_T, Alc_tar;
  extern float T25, T100, R25, R100, Ttemp;
// -----------------------------------------Для взаимодействия с пользователем---------------------------------------------
 extern int BtnEnterFlg, BtnSelFlg;
 extern bool Rec;   
 extern int8_t spk_trigger, spk_count, spk_on, DispMode, spk_max_count;

// Объявления функций
void publishMQTTData();
void mqttCallback(char* topic, byte* payload, unsigned int length);
void mqttConnect();
void setupMQTT();
void loopMQTT();

// Добавляем структуру для хранения логов
struct MQTTDebugLog {
    String connectionLog;
    String lastError;
    String lastStatus;
    unsigned long lastAttemptTime;
    int connectionAttempts;
};

extern MQTTDebugLog mqttDebugLog;
#endif