// Версия 3.01b от 30.03.25
 #include <Arduino.h>
 #include <Wire.h>
 #include <ESP8266WiFi.h>
 #include "OneWireHub.h"
 #include "DS18B20.h"
 #include <ASOLED_ESP8266.h>     // Библиотека дисплея
 #include <XGZP6897D.h>  // Библиотека датчика давления XGZP6897D
 #include "HX710B.h"     // Библиотека датчика давления на АЦП HX710B
 #include <EEPROM.h>
 #include "Izm_config.h"
 #include "wifi_utils.h"
 #include "oled_display.h"
 #include "mqtt_control.h"
 #include "OTA.h"
 #include "ADS.h"
 #include "web_server.h"

void setup() {                                                   // Инициализация             
   Serial.begin(115200);
  ESP.wdtEnable(10000);                  // Установка таймера watchdog  
  Wire.begin();                         // Инициализация I2C
  initOLED();                        // Инициализация OLED дисплея  

  EEPROM_Init();                        // Инициализация переменных из EEPROM
  pinMode(BtnEnter, INPUT_PULLUP);      // Инициализация кнопок
  pinMode(BtnSel, INPUT_PULLUP);  
  pinMode(BtnUp, INPUT_PULLUP);  
  pinMode(BtnDwn, INPUT_PULLUP);
  pinMode(Pin040DR1, INPUT_PULLUP); // Пин перемычки для определения наличия датчика давления 040DR1
  pinMode(pin_spk, OUTPUT);  digitalWrite(pin_spk, 0); // Готовим зуммер
  ADS_Init();

}
void loop() {                                                                 // Основной цикл
    ESP.wdtFeed();  // Сброс таймера watchdog
    ADS_Loop(); // Считываем температуры, выводим на дисплей, ожидаем запросов по 1ware
 
    static bool flstart = true;
    if (flstart) {
   unsigned long timeout = millis(); //ждем 10 сек, чтоб Самовар приконнектился, потом запускаем сетевые сервисы поочередно
  if (timeout >= 12000) {
    static bool wifistart = true, wificonnected = false;
      ESP.wdtFeed();
      static long time_start_wifi;
      if (wifistart) {initWiFi(); wifistart = false; time_start_wifi = millis();  }              // Загрузка сохраненных данных и  запуск Wi-Fi
      else {
        if (WiFi.status() == WL_CONNECTED) wificonnected = true;
        else {if ((time_start_wifi + 10000) < millis()) {wificonnected = true; startHotspot();}}
      }
      ESP.wdtFeed();
      if (wificonnected) {
        setupWebServer();            // Запуск веб-сервера
        ESP.wdtFeed();
        initOTA();                   // Запуск ОТА
        ESP.wdtFeed();
        setupMQTT();                 // запуск MQTT
        flstart = false;}
    } 
    } else {                            // Когда сетевые сервисы запущены 
    MDNS.update(); ArduinoOTA.handle(); //Обработка ОТА
    loopMQTT();
    }
  
}
