// web_server.h
#ifndef WEB_SERVER_H
#define WEB_SERVER_H

#include <Arduino.h>
//#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <EEPROM.h>
#include "Izm_config.h"
#include "mqtt_control.h" 

// Внешние переменные
extern uint16_t m_adc[151];
extern MQTTDebugLog mqttDebugLog;
extern float Temp[9];
extern uint8_t ntcEn[9];
extern float pressure[4];
extern float Alc_T;
extern int8_t spk_on;
extern float T_target;
extern String savedSSID;
extern String savedPass;
extern bool hotspotMode;
extern String mqtt_server;
extern uint mqtt_port;
extern String mqtt_user;
extern String mqtt_password;
extern String mqtt_topic_temp;
extern String mqtt_topic_press;
extern String mqtt_topic_alc;
extern String mqtt_topic_status;
extern uint8_t mqtt_attempts;
extern bool debug_mode;
extern float Temp_debug[8];
//------------------------------------------Значения для датчиков давления-------------------------------------------------
 extern int8_t Pressure_enable[4];  
 extern float pressure[4], temperature[4], B25, B25t; 
 extern float dPress_1, KTemp_1, BaseTemp_1, dPt_1, ADSt1, ADSt, PressureBaseADS, PressureQ, KTemp_2, BaseTemp, dPress_2, dPt_2, BaseTemp_2, U33, Uref, R10, R62;
 extern float HX710B_Mult, KTemp_3, BaseTemp_3, dPress_3, Pressure3Temp, dPt_3;
 extern uint8_t N_dPressureAlc;  
 extern float k_Alc_T, k_Alc, Alc, Alc_T, Alc_tar;
  extern float T25, T100, R25, R100, Ttemp;
// -----------------------------------------Для взаимодействия с пользователем---------------------------------------------
 extern int BtnEnterFlg, BtnSelFlg;
 extern bool Rec;   
 extern int8_t spk_trigger, spk_count, spk_on, DispMode, spk_max_count;

// Внешние функции
extern void startHotspot();
extern void writeEEPROM(int addr, String data, byte limit);
extern void ConnectWIFI(String SSID, String Pass);
extern void WiFiSetup(String SSID, String Pass);
extern void hotspotSetup();

// Функции модуля
void setupWebServer();
String getSensorDataJSON();
String getChartDataJSON();
void publishMQTTData();
bool reconnectMQTT();

#endif
